/****************************************************
*  CZ~i@XC8@(sample10.c)
*  CCP̎g
*  @\
*   POTɂCCP̃f[eBύXLED̖邳
****************************************************/
#include  <xc.h>
/***** RtBM[V̐ݒ *********/
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)
// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PLLEN = OFF      // PLL Enable (4x PLL disabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

/******* C[v   *********/
void main()
{
    int i;

    /* NbNݒ@32MHz */
    OSCCONbits.IRCF = 14;           // 8MHzI
    OSCCONbits.SPLLEN = 1;          // PLL On 32MHzU    
    /* I/O|[gݒ */
    ANSELA = 0;                     // |[gASfW^
    ANSELB = 0x04;                  // |[gB AN8̂݃AiO
    ANSELD = 0;                     // |[gDׂăfW^ɐݒ
    ANSELE = 0;                     // |[gEׂăfW^
    TRISA = 0;                      // |[gAׂďo
    TRISB = 0xC4;                   // |[gB AN8
    TRISC = 0x1B;                   // |[gC
    TRISD = 0x04;                   // |[gD@RD2̂ݓ
    TRISE = 0x00;                   // |[gEׂďo
    LATE = 0;                       // |[gE@񂷂ׂăIt
    /** ^C}2ݒ **/
    T4CON = 0;                      // ^C}2~
    TMR4 = 0;                       // Zbg
    PR4 = 0xFF;                     // ݒ 8MHz/256 = 31.25kHz
    T4CON = 0x00;                   // 8MHzNbNAvXP[1/1 |Xg=1/1
    /** ADC **/
    ADCON0 = 0x21;                  // Select AN8
    ADCON1 = 0x20;                  // Fosc/32, VDD-VSS@l
    /** ECCP3̏ݒ **/
    CCP3CON = 0x0F;                 // PWM Mode Active Low
    CCPTMRS0bits.C3TSEL = 1;        // Timer4I
    PSTR3CON = 0x03;                // P3A,P3B Active
    /** CCP4̏ݒ@PWM[h ***/
    CCP4CON = 0x0F;                 // PWM Mode
    CCPTMRS0bits.C4TSEL = 1;        // Timer4I
    /** CCP5̏ݒ **/
    CCP5CON = 0x0F;                 // PWM Mode
    CCPTMRS1bits.C5TSEL = 1;        // Timer4I
    /** CCPʐݒ **/
    T4CONbits.TMR4ON = 1;           // ^C}2X^[g
    /******** C[v  ********/
    while(1)                        // iv[v
    {
        /** POT**/
        ADCON0 = 0x21;                  // AN8I
        for(i=0; i<100; i++);           // ANCWV^C҂
        ADCON0bits.GO = 1;              // ADϊJn
        while(ADCON0bits.GO);           // ADϊI҂
        /** f[eB̃Zbg **/
        CCPR3L = ADRESH;                // ECCP3f[eB8rbgݒ
        CCPR4L = ADRESH;                // CCP4f[eB8rbgݒ
        CCPR5L = ADRESH;                // CCP5f[eB8rbgݒ
        CCP3CON &= 0xCF;                // ECCP3f[eB2rbgNA
        CCP4CON &= 0xCF;                // CCP4f[eB2rbgNA
        CCP5CON &= 0xCF;                // CCP5f[eB2rbgNA
        CCP3CON |= (ADRESL >> 2);       // ECCP3f[eB2rbgݒ
        CCP4CON |= (ADRESL >> 2);       // CCP4f[eB2rbgݒ
        CCP5CON |= (ADRESL >> 2);       // CCP5f[eB2rbgݒ
    }
}


